<?php //00cfe
// *************************************************************************
// *                                                                       *
// * WHMCS - The Complete Client Management, Billing & Support Solution    *
// * Copyright (c) WHMCS Ltd. All Rights Reserved,                         *
// * Created: February 2012                                                *
// *                                                                       *
// *************************************************************************
// *                                                                       *
// * Email: info@whmcs.com                                                 *
// * Website: http://www.whmcs.com                                         *
// *                                                                       *
// *************************************************************************
// *                                                                       *
// * This software is furnished under a license and may be used and copied *
// * only  in  accordance  with  the  terms  of such  license and with the *
// * inclusion of the above copyright notice.  This software  or any other *
// * copies thereof may not be provided or otherwise made available to any *
// * other person.  No title to and  ownership of the  software is  hereby *
// * transferred.                                                          *
// *                                                                       *
// * You may not reverse  engineer, decompile, defeat  license  encryption *
// * mechanisms, or  disassemble this software product or software product *
// * license.  WHMCompleteSolution may terminate this license if you don't *
// * comply with any of the terms and conditions set forth in our end user *
// * license agreement (EULA).  In such event,  licensee  agrees to return *
// * licensor  or destroy  all copies of software  upon termination of the *
// * license.                                                              *
// *                                                                       *
// * Please see the EULA file for the full End User License Agreement.     *
// *                                                                       *
// *************************************************************************
if( !defined( "WHMCS" ) )
{
	exit( "This file cannot be accessed directly" );
}

function licensing_config()
{
	$configarray = array( "name" => "Licensing Manager", "description" => "This addon allows you to license and distribute your own applications securely using the same system we use for WHMCS", "version" => "3.0", "author" => "WHMCS", "language" => "english", "fields" => array() );
	global $licensing;
	$validlicense = false;
	foreach( $licensing->keydata['addons'] as $addon )
	{
		if( $addon['name'] == "Licensing Addon" && $addon['status'] == "Active" )
		{
			$validlicense = true;
			break;
		}
	}
	if( !$validlicense )
	{
		$configarray['fields']['license'] = array( "FriendlyName" => "License Check Failed", "Type" => "", "Description" => "You need to purchase the licensing addon from <a href=\"http://dereferer.ws/?http://www.whmcs.com/addons/licensing\" target=\"_blank\">www.whmcs.com/addons/licensing</a> to enable the use of this addon" );
	}
	else
	{
		$configarray['fields'] = array( "clientverifytool" => array( "FriendlyName" => "Public License Verification Tool", "Type" => "yesno", "Description" => "Tick this box to enable the Client Area License Verification Tool (accessed via /index.php?m=licensing)" ), "maxreissues" => array( "FriendlyName" => "Maximum Allowed Reissues", "Type" => "text", "Size" => "4", "Default" => "10", "Description" => "Enter the maximum number of reissues you want to allow (abuse protection)" ), "logprune" => array( "FriendlyName" => "Auto Logs Prune", "Type" => "text", "Size" => "4", "Default" => "90", "Description" => "Enter the number of days to keep license access log history for" ) );
	}
	return $configarray;
}

function licensing_activate()
{
	$query = "CREATE TABLE `mod_licensing` (`id` INT( 10 ) NOT NULL AUTO_INCREMENT PRIMARY KEY ,`serviceid` INT( 10 ) NOT NULL ,`licensekey` TEXT NOT NULL ,`validdomain` TEXT NOT NULL ,`validip` TEXT NOT NULL ,`validdirectory` TEXT NOT NULL ,`reissues` INT( 1 ) NOT NULL ,`status` ENUM( 'Active', 'Reissued', 'Suspended', 'Expired' ) NOT NULL ,`lastaccess` datetime NOT NULL default '0000-00-00 00:00:00')";
	full_query( $query );
	$query = "CREATE TABLE `mod_licensinglog` (`id` INT( 10 ) NOT NULL AUTO_INCREMENT PRIMARY KEY ,`licenseid` INT( 10 ) NOT NULL ,`domain` TEXT NOT NULL ,`ip` TEXT NOT NULL ,`path` TEXT NOT NULL ,`message` TEXT NOT NULL ,`datetime` datetime NOT NULL default '0000-00-00 00:00:00')";
	full_query( $query );
	$query = "CREATE TABLE `mod_licensingbans` (`id` INT( 10 ) NOT NULL AUTO_INCREMENT PRIMARY KEY ,`type` VARCHAR(1) NOT NULL ,`value` TEXT NOT NULL ,`notes` TEXT NOT NULL )";
	full_query( $query );
}

function licensing_deactivate()
{
	$query = "DROP TABLE `mod_licensing`";
	full_query( $query );
	$query = "DROP TABLE `mod_licensinglog`";
	full_query( $query );
	$query = "DROP TABLE `mod_licensingbans`";
	full_query( $query );
}

function licensing_output( $vars )
{
	global $aInt;
	global $numrows;
	global $tabledata;
	global $page;
	global $limit;
	global $jscode;
	$modulelink = $vars['modulelink'];
	$action = isset( $_REQUEST['action'] ) ? $_REQUEST['action'] : "";
	$id = ( integer )$_REQUEST['id'];
	echo "<style>\r\n.licensinglinksbar {\r\n	padding:10px 25px 10px 25px;\r\n	background-color:#6CAD41;\r\n	font-weight:bold;\r\n	font-size: 14px;\r\n	color: #5A7B2F;\r\n	margin: 0 0 15px 0;\r\n	-moz-border-radius: 5px;\r\n	-webkit-border-radius: 5px;\r\n	-o-border-radius: 5px;\r\n	border-radius: 5px;\r\n}\r\n.licensinglinksbar a {\r\n	color: #fff;\r\n	font-weight: normal;\r\n}\r\n</style>\r\n\r\n<div class=\"licensinglinksbar\">\r\n<a href=\"".$modulelink."\">Home</a> | <a href=\"".$modulelink."&action=list\">Search/Browse Licenses</a> | <a href=\"".$modulelink."&action=bans\">Ban Control</a> | <a href=\"".$modulelink."&action=log\">License Access Logs</a> | <a href=\"http://dereferer.ws/?http://docs.whmcs.com/Licensing_Addon\" target=\"_blank\">Help</a>\r\n</div>\r\n\r\n";
	if( !$action )
	{
		echo "\r\n<h2>Statistics</h2>\r\n\r\n<table width=\"90%\" align=\"center\">\r\n<tr><td width=\"33%\">\r\n\r\n<div style=\"margin:0 25px;padding:15px;font-family:Trebuchet MS,Tahoma;text-align:center;font-size:20px;background-color:#E7F1C0;-moz-border-radius: 5px;-webkit-border-radius: 5px;-o-border-radius: 5px;border-radius: 5px;\">\r\nActive Licenses<br />\r\n";
		echo "<strong>";
		echo get_query_val( "mod_licensing", "COUNT(*)", "status='Reissued' OR status='Active'" );
		echo "</strong>\r\n</div>\r\n\r\n</td><td width=\"33%\">\r\n\r\n<div style=\"margin:0 25px;padding:15px;font-family:Trebuchet MS,Tahoma;text-align:center;font-size:20px;background-color:#F2E8BF;-moz-border-radius: 5px;-webkit-border-radius: 5px;-o-border-radius: 5px;border-radius: 5px;\">\r\nSuspended Licenses<br />\r\n";
		echo "<strong>";
		echo get_query_val( "mod_licensing", "COUNT(*)", "status='Suspended'" );
		echo "</strong>\r\n</div>\r\n\r\n</td><td width=\"33%\">\r\n\r\n<div style=\"margin:0 25px;padding:15px;font-family:Trebuchet MS,Tahoma;text-align:center;font-size:20px;background-color:#F2BFBF;-moz-border-radius: 5px;-webkit-border-radius: 5px;-o-border-radius: 5px;border-radius: 5px;\">\r\nExpired Licenses<br />\r\n";
		echo "<strong>";
		echo get_query_val( "mod_licensing", "COUNT(*)", "status='Expired'" );
		echo "</strong>\r\n</div>\r\n\r\n</td></tr>\r\n</table>\r\n\r\n<table width=\"90%\" align=\"center\">\r\n<tr><td width=\"50%\">\r\n\r\n<div style=\"margin:0 25px;padding:15px;font-family:Trebuchet MS,Tahoma;text-align:center;font-size:20px;background-color:#efefef;-moz-border-radius: 5px;-webkit-border-radius: 5px;-o-border-radius: 5px;border-radius: 5px;\">\r\nTotal Licenses in Database<br />\r\n";
		echo "<strong>";
		echo get_query_val( "mod_licensing", "COUNT(*)", "" );
		echo "</strong>\r\n</div>\r\n\r\n</td><td width=\"50%\">\r\n\r\n<div style=\"margin:0 25px;padding:15px;font-family:Trebuchet MS,Tahoma;text-align:center;font-size:20px;background-color:#efefef;-moz-border-radius: 5px;-webkit-border-radius: 5px;-o-border-radius: 5px;border-radius: 5px;\">\r\nAccessed within the Past 30 Days<br />\r\n";
		echo "<strong>";
		echo get_query_val( "mod_licensing", "COUNT(*)", "lastaccess>='".date( "Y-m-d", mktime( 0, 0, 0, date( "m" ), date( "d" ) - 30, date( "Y" ) ) )."'" );
		echo "</strong>\r\n</div>\r\n\r\n</td></tr>\r\n</table>\r\n\r\n<br />\r\n\r\n<h2>Search</h2>\r\n\r\n<form method=\"post\" action=\"";
		echo $modulelink;
		echo "&action=list\">\r\n\r\n<table class=\"form\" width=\"100%\" border=\"0\" cellspacing=\"2\" cellpadding=\"3\">\r\n<tr><td width=\"15%\" class=\"fieldlabel\">Product/License</td><td class=\"fieldarea\">";
		echo "<select name=\"search_pid\"><option value=\"0\">- Any -</option>";
		$result = select_query( "tblproducts", "id,name", array( "servertype" => "licensing" ), "name", "ASC" );
		while( $data = mysql_fetch_array( $result ) )
		{
			echo "<option value=\"".$data['id']."\">".$data['name']."</option>";
		}
		echo "</select></td></tr>\r\n<tr><td width=\"15%\" class=\"fieldlabel\">License Key</td><td class=\"fieldarea\"><input type=\"text\" name=\"search_licensekey\" size=\"30\" value=\"";
		echo $search_licensekey;
		echo "\" /></td></tr>\r\n<tr><td class=\"fieldlabel\">Domain</td><td class=\"fieldarea\"><input type=\"text\" name=\"search_domain\" size=\"30\" value=\"";
		echo $search_domain;
		echo "\" /></td></tr>\r\n<tr><td class=\"fieldlabel\">IP</td><td class=\"fieldarea\"><input type=\"text\" name=\"search_ip\" size=\"30\" value=\"";
		echo $search_ip;
		echo "\" /></td></tr>\r\n<tr><td class=\"fieldlabel\">Directory</td><td class=\"fieldarea\"><input type=\"text\" name=\"search_dir\" size=\"60\" value=\"";
		echo $search_dir;
		echo "\" /></td></tr>\r\n<tr><td class=\"fieldlabel\">Status</td><td class=\"fieldarea\">";
		echo "<select name=\"search_status\">\r\n<option value=\"\">- Any -</option>\r\n<option>Reissued</option>\r\n<option>Active</option>\r\n<option>Suspended</option>\r\n<option>Expired</option>\r\n</select></td></tr>\r\n</table>\r\n\r\n<p align=\"center\"><input type=\"submit\" value=\"Search\" class=\"button\" /></p>\r\n\r\n</form>\r\n\r\n";
	}
	else if( $action == "list" )
	{
		echo "\r\n<form method=\"post\" action=\"";
		echo $modulelink;
		echo "&action=list\">\r\n\r\n<h2>Search/Browse Licenses</h2>\r\n\r\n<table class=\"form\" width=\"100%\" border=\"0\" cellspacing=\"2\" cellpadding=\"3\">\r\n<tr><td width=\"15%\" class=\"fieldlabel\">Product/License</td><td class=\"fieldarea\">";
		echo "<select name=\"search_pid\"><option value=\"0\">- Any -</option>";
		$result = select_query( "tblproducts", "id,name", array( "servertype" => "licensing" ), "name", "ASC" );
		while( $data = mysql_fetch_array( $result ) )
		{
			echo "<option value=\"".$data['id']."\"";
			if( $_REQUEST['search_pid'] == $data['id'] )
			{
				echo " selected";
			}
			echo ">".$data['name']."</option>";
		}
		echo "</select></td></tr>\r\n<tr><td width=\"15%\" class=\"fieldlabel\">License Key</td><td class=\"fieldarea\"><input type=\"text\" name=\"search_licensekey\" size=\"30\" value=\"";
		echo $_REQUEST['search_licensekey'];
		echo "\" /></td></tr>\r\n<tr><td class=\"fieldlabel\">Domain</td><td class=\"fieldarea\"><input type=\"text\" name=\"search_domain\" size=\"30\" value=\"";
		echo $_REQUEST['search_domain'];
		echo "\" /></td></tr>\r\n<tr><td class=\"fieldlabel\">IP</td><td class=\"fieldarea\"><input type=\"text\" name=\"search_ip\" size=\"30\" value=\"";
		echo $_REQUEST['search_ip'];
		echo "\" /></td></tr>\r\n<tr><td class=\"fieldlabel\">Directory</td><td class=\"fieldarea\"><input type=\"text\" name=\"search_dir\" size=\"60\" value=\"";
		echo $_REQUEST['search_dir'];
		echo "\" /></td></tr>\r\n<tr><td class=\"fieldlabel\">Status</td><td class=\"fieldarea\">";
		echo "<select name=\"search_status\">\r\n<option value=\"\">- Any -</option>\r\n<option";
		if( $_REQUEST['search_status'] == "Reissued" )
		{
			echo " selected";
		}
		echo ">Reissued</option>\r\n<option";
		if( $_REQUEST['search_status'] == "Active" )
		{
			echo " selected";
		}
		echo ">Active</option>\r\n<option";
		if( $_REQUEST['search_status'] == "Suspended" )
		{
			echo " selected";
		}
		echo ">Suspended</option>\r\n<option";
		if( $_REQUEST['search_status'] == "Expired" )
		{
			echo " selected";
		}
		echo ">Expired</option>\r\n</select></td></tr>\r\n</table>\r\n\r\n<p align=\"center\"><input type=\"submit\" value=\"Search\" class=\"button\" /></p>\r\n\r\n</form>\r\n\r\n";
		$where = array();
		if( $_REQUEST['search_pid'] )
		{
			$where['packageid'] = $_REQUEST['search_pid'];
		}
		if( $_REQUEST['search_licensekey'] )
		{
			$where['licensekey'] = array( "sqltype" => "LIKE", "value" => trim( $_REQUEST['search_licensekey'] ) );
		}
		if( $_REQUEST['search_domain'] )
		{
			$where['validdomain'] = array( "sqltype" => "LIKE", "value" => trim( $_REQUEST['search_domain'] ) );
		}
		if( $_REQUEST['search_ip'] )
		{
			$where['validip'] = array( "sqltype" => "LIKE", "value" => trim( $_REQUEST['search_ip'] ) );
		}
		if( $_REQUEST['search_dir'] )
		{
			$where['validdirectory'] = array( "sqltype" => "LIKE", "value" => trim( $_REQUEST['search_dir'] ) );
		}
		if( $_REQUEST['search_status'] )
		{
			$where['status'] = $_REQUEST['search_status'];
		}
		$aInt->sortableTableInit( "licensesmanager", "ASC" );
		$result = select_query( "mod_licensing", "mod_licensing.*", $where, "lastaccess", "DESC", "", "tblhosting ON tblhosting.id=mod_licensing.serviceid" );
		$numrows = mysql_num_rows( $result );
		if( count( $where ) && $numrows == 1 )
		{
			$data = mysql_fetch_array( $result );
			$id = $data['id'];
			header( "Location: {$modulelink}&action=manage&id={$id}" );
			exit();
		}
		$result = select_query( "mod_licensing", "mod_licensing.*", $where, "lastaccess", "DESC", $page * $limit.",{$limit}", "tblhosting ON tblhosting.id=mod_licensing.serviceid" );
		while( $data = mysql_fetch_array( $result ) )
		{
			$id = $data['id'];
			$serviceid = $data['serviceid'];
			$licensekey = $data['licensekey'];
			$validdomain = $data['validdomain'];
			$validip = $data['validip'];
			$validdirectory = $data['validdirectory'];
			$status = $data['status'];
			$lastaccess = $data['lastaccess'];
			$lastaccess = "Never";
			$lastaccess = fromMySQLDate( $lastaccess, "time" );
			$validdomain = explode( ",", $validdomain );
			$validip = explode( ",", $validip );
			$validdomain = $validdomain[0];
			$validip = $validip[0];
			$tabledata[] = array( "<a href=\"clientshosting.php?id={$serviceid}\" target=\"_blank\">{$licensekey}</a>", $validdomain, $validip, $lastaccess, $status, "<a href=\"{$modulelink}&action=manage&id={$id}\"><img src=\"images/edit.gif\" border=\"0\"></a>" );
		}
		echo $aInt->sortableTable( array( array( "licensekey", "License Key" ), array( "validdomain", "Valid Domains" ), array( "validip", "Valid IPs" ), array( "lastaccess", "Last Access" ), array( "status", "Status" ), "" ), $tabledata );
	}
	else if( $action == "manage" )
	{
		if( $_REQUEST['save'] )
		{
			update_query( "mod_licensing", array( "validdomain" => $_REQUEST['validdomain'], "validip" => $_REQUEST['validip'], "validdirectory" => $_REQUEST['validdirectory'], "reissues" => $_REQUEST['reissues'], "status" => $_REQUEST['status'] ), array( "id" => $id ) );
			header( "Location: {$modulelink}&action=manage&id={$id}" );
			exit();
		}
		$result = select_query( "mod_licensing", "", array( "id" => $id ) );
		$data = mysql_fetch_array( $result );
		$id = $data['id'];
		if( !$id )
		{
			echo "<p>License Not Found. Please go back and try again.</p>";
			return false;
		}
		$serviceid = $data['serviceid'];
		$licensekey = $data['licensekey'];
		$validdomain = $data['validdomain'];
		$validip = $data['validip'];
		$validdirectory = $data['validdirectory'];
		$reissues = $data['reissues'];
		$status = $data['status'];
		$lastaccess = $data['lastaccess'];
		if( $lastaccess == "0000-00-00 00:00:00" )
		{
			$lastaccess = "Never";
		}
		else
		{
			$lastaccess = fromMySQLDate( $lastaccess, "time" );
		}
		$data = get_query_vals( "tblhosting", "tblproductgroups.name,tblproducts.name", array( "tblhosting.id" => $serviceid ), "", "", "", "tblproducts ON tblhosting.packageid=tblproducts.id INNER JOIN tblproductgroups ON tblproductgroups.id=tblproducts.gid" );
		$productname = $data[0]." - ".$data[1];
		echo "\r\n<h2>Manage License Key</h2>\r\n\r\n<form method=\"post\" action=\"";
		echo $modulelink;
		echo "&action=manage&id=";
		echo $id;
		echo "\">\r\n<input type=\"hidden\" name=\"save\" value=\"true\" />\r\n\r\n<table class=\"form\" width=\"100%\" border=\"0\" cellspacing=\"2\" cellpadding=\"3\">\r\n<tr><td class=\"fieldlabel\" width=\"20%\">Product/Service</td><td class=\"fieldarea\" height=\"24\">";
		echo $productname;
		echo "</td></tr>\r\n<tr><td class=\"fieldlabel\">License Key</td><td class=\"fieldarea\"><input type=\"text\" size=\"40\" value=\"";
		echo $licensekey;
		echo "\" readonly=\"true\" /> ";
		echo "<span style=\"color:#cccccc;\">(Not Editable)</span></td></tr>\r\n<tr><td class=\"fieldlabel\">Valid Domains</td><td class=\"fieldarea\"><textarea name=\"validdomain\" rows=2 cols=80>";
		echo $validdomain;
		echo "</textarea></td></tr>\r\n<tr><td class=\"fieldlabel\">Valid IPs</td><td class=\"fieldarea\"><textarea name=\"validip\" rows=2 cols=80>";
		echo $validip;
		echo "</textarea></td></tr>\r\n<tr><td class=\"fieldlabel\">Valid Directory</td><td class=\"fieldarea\"><textarea name=\"validdirectory\" rows=2 cols=80>";
		echo $validdirectory;
		echo "</textarea></td></tr>\r\n<tr><td class=\"fieldlabel\">Number of Reissues</td><td class=\"fieldarea\"><input type=\"text\" name=\"reissues\" size=\"10\" value=\"";
		echo $reissues;
		echo "\"></td></tr>\r\n<tr><td class=\"fieldlabel\">Status</td><td class=\"fieldarea\">";
		echo "<select name=\"status\">\r\n<option";
		if( $status == "Reissued" )
		{
			echo " selected";
		}
		echo ">Reissued</option>\r\n<option";
		if( $status == "Active" )
		{
			echo " selected";
		}
		echo ">Active</option>\r\n<option";
		if( $status == "Suspended" )
		{
			echo " selected";
		}
		echo ">Suspended</option>\r\n<option";
		if( $status == "Expired" )
		{
			echo " selected";
		}
		echo ">Expired</option>\r\n</select></td></tr>\r\n<tr><td class=\"fieldlabel\">Last Access</td><td class=\"fieldarea\" height=\"24\">";
		echo $lastaccess;
		echo "</td></tr>\r\n</table>\r\n\r\n<p align=\"center\"><input type=\"button\" value=\"&laquo; Back to List\" onclick=\"history.go(-1)\" /> <input type=\"submit\" value=\"Save Changes\" class=\"button\" /> <input type=\"button\" value=\"Product Details &raquo;\" onclick=\"window.location='clientshosting.php?id=";
		echo $serviceid;
		echo "'\" /></p>\r\n\r\n</form>\r\n\r\n<h2>Recent Access</h2>\r\n\r\n";
		$aInt->sortableTableInit( "nopagination" );
		$result = select_query( "mod_licensinglog", "", array( "licenseid" => $id ), "id", "DESC", "0,10" );
		while( $data = mysql_fetch_array( $result ) )
		{
			$domain = $data['domain'];
			$ip = $data['ip'];
			$path = $data['path'];
			$message = $data['message'];
			$datetime = $data['datetime'];
			$datetime = fromMySQLDate( $datetime, true );
			$tabledata[] = array( $datetime, $domain, $ip, $path, $message );
		}
		echo $aInt->sortableTable( array( "Date", "Domain", "IP", "Path", "Result" ), $tabledata );
	}
	else
	{
		if( $action == "bans" )
		{
			if( $_REQUEST['save'] )
			{
				check_token();
				if( trim( $_REQUEST['banvalue'] ) )
				{
					insert_query( "mod_licensingbans", array( "value" => trim( $_REQUEST['banvalue'] ), "notes" => trim( $_REQUEST['bannote'] ) ) );
				}
				header( "Location: {$modulelink}&action=bans" );
				exit();
			}
			if( $_REQUEST['delete'] )
			{
				check_token();
				delete_query( "mod_licensingbans", array( "id" => $_REQUEST['delete'] ) );
				header( "Location: {$modulelink}&action=bans" );
				exit();
			}
			$jscode = "function doDelete(id) {\r\n	if(confirm(\"Are you sure you want to delete this ban entry?\")) {\r\n		window.location='".$modulelink."&action=bans&delete='+id+'".generate_token( "link" )."';\r\n	}\r\n}\r\n";
			echo "\r\n<h2>Ban Control</h2>\r\n\r\n<form method=\"post\" action=\"";
			echo $modulelink;
			echo "&action=bans\">\r\n<input type=\"hidden\" name=\"save\" value=\"true\" />\r\n\r\n<table class=\"form\" width=\"100%\" border=\"0\" cellspacing=\"2\" cellpadding=\"3\">\r\n<tr><td class=\"fieldlabel\" width=\"20%\">Value</td><td class=\"fieldarea\"><input type=\"text\" name=\"banvalue\" size=\"40\" /></td></tr>\r\n<tr><td class=\"fieldlabel\">Reason/Notes</td><td class=\"fieldarea\"><input type=\"text\" name=\"bannote\" size=\"80\" /></td></tr>\r\n</table>\r\n\r\n<p ali";
			echo "gn=\"center\"><input type=\"submit\" value=\"Add Ban\" /></p>\r\n\r\n</form>\r\n\r\n";
			$aInt->sortableTableInit( "nopagination" );
			$result = select_query( "mod_licensingbans", "", "", "value", "ASC" );
			while( $data = mysql_fetch_array( $result ) )
			{
				$id = $data['id'];
				$value = $data['value'];
				$notes = $data['notes'];
				$tabledata[] = array( $value, $notes, "<a href=\"#\" onClick=\"doDelete('".$id."');return false\"><img src=\"images/delete.gif\" width=\"16\" height=\"16\" border=\"0\" alt=\"".$aInt->lang( "global", "delete" )."\"></a>" );
			}
			echo $aInt->sortableTable( array( "Domain/IP", "Ban Reason/Notes", "" ), $tabledata );
		}
		else
		{
			if( $action == "log" )
			{
				echo "\r\n<h2>License Access Logs</h2>\r\n\r\n<form method=\"post\" action=\"";
				echo $modulelink;
				echo "&action=log\">\r\n<p align=\"center\"><b>Search/Filter</b>\r\nDomain: <input type=\"text\" name=\"search_domainlog\" size=\"30\" value=\"";
				echo $_REQUEST['search_domainlog'];
				echo "\" />\r\nIP: <input type=\"text\" name=\"search_iplog\" size=\"15\" value=\"";
				echo $_REQUEST['search_iplog'];
				echo "\" />\r\nDir: <input type=\"text\" name=\"search_dirlog\" size=\"25\" value=\"";
				echo $_REQUEST['search_dirlog'];
				echo "\" />\r\nStatus: <input type=\"text\" name=\"search_message\" size=\"25\" value=\"";
				echo $_REQUEST['search_message'];
				echo "\" />\r\n<input type=\"submit\" value=\"Go\" class=\"button\" /></p>\r\n</form>\r\n\r\n";
				$where = array();
				if( $_REQUEST['search_domainlog'] )
				{
					$where['domain'] = array( "sqltype" => "LIKE", "value" => trim( $_REQUEST['search_domainlog'] ) );
				}
				if( $_REQUEST['search_iplog'] )
				{
					$where['ip'] = array( "sqltype" => "LIKE", "value" => trim( $_REQUEST['search_iplog'] ) );
				}
				if( $_REQUEST['search_dirlog'] )
				{
					$where['path'] = array( "sqltype" => "LIKE", "value" => trim( $_REQUEST['search_dirlog'] ) );
				}
				if( $_REQUEST['search_message'] )
				{
					$where['message'] = array( "sqltype" => "LIKE", "value" => trim( $_REQUEST['search_message'] ) );
				}
				$result = select_query( "mod_licensinglog", "", $where, "id", "DESC" );
				$numrows = mysql_num_rows( $result );
				$aInt->sortableTableInit( "datetime", "ASC" );
				$result = select_query( "mod_licensinglog", "", $where, "id", "DESC", $page * $limit.",{$limit}" );
				while( $data = mysql_fetch_array( $result ) )
				{
					$domain = $data['domain'];
					$ip = $data['ip'];
					$path = $data['path'];
					$message = $data['message'];
					$datetime = $data['datetime'];
					$datetime = fromMySQLDate( $datetime, true );
					$tabledata2[] = array( $datetime, $domain, $ip, $path, $message );
				}
				echo $aInt->sortableTable( array( "Date", "Domain", "IP", "Path", "Status Message" ), $tabledata2 );
			}
		}
	}
}

function licensing_clientarea( $vars )
{
	if( !$vars['clientverifytool'] )
	{
		return false;
	}
	$domain = trim( $_POST['domain'] );
	$check = false;
	$results = array();
	if( $domain )
	{
		$check = true;
		$result = select_query( "mod_licensing", "mod_licensing.*,tblproducts.name", "validdomain LIKE '%".db_escape_string( $domain )."%' OR validip LIKE '%".db_escape_string( $domain )."%'", "", "", "", "tblhosting ON tblhosting.id=mod_licensing.serviceid INNER JOIN tblproducts ON tblproducts.id=tblhosting.packageid" );
		while( $data = mysql_fetch_array( $result ) )
		{
			$licenseid = $data['id'];
			$productname = $data['name'];
			$status = $data['status'];
			$validdomains = explode( ",", $data['validdomain'] );
			$validips = explode( ",", $data['validip'] );
			if( in_array( $domain, $validdomains ) || in_array( $domain, $validips ) )
			{
				$results[] = array( "productname" => $productname, "domain" => $validdomains[0], "ip" => $validips[0], "status" => $status );
			}
		};
	}
	return array( "pagetitle" => "License Verification Tool", "breadcrumb" => array( "index.php?m=licensing" => "License Verification Tool" ), "templatefile" => "licenseverify", "vars" => array( "domain" => $domain, "check" => $check, "results" => $results ) );
}
?>